function FM(x0::Array,step0::Real,tol::Real,maxit::Int,f::Function)
	Delta = step0
	x = x0
	n = length(x)
	d = zeros(n)
	for k = 1:maxit
		if Delta <= tol
			break
		end
		xtilde = x
		for i = 1:n
			d[i] = 1.0
			if f(xtilde + Delta * d) < f(xtilde)
				while f(xtilde + Delta * d) < f(xtilde)
					xtilde = xtilde + Delta * d
				end
			elseif f(xtilde - Delta * d) < f(xtilde)
				while f(xtilde - Delta * d) < f(xtilde)
					xtilde = xtilde - Delta * d
				end
			end
			d[i] = 0.0
		end
		if f(xtilde) >= f(x)
			Delta = Delta/2
		else
			x = xtilde
		end
		@printf("%6d f(xx) = %13.6e step = %13.6e\n",k,f(x),Delta)
	end

	return x
end

function CS(x0::Array,step0::Real,tol::Real,maxit::Int,f::Function)
	Delta = step0
	x = x0
	n = length(x)
	d = zeros(n)
	for k = 1:maxit
		if Delta <= tol
			break
		end
		i = 1
		fz= Inf
		z = zeros(n)
		for i = 1:n
			d[i] = 1.0
			if f(x+Delta*d) < f(x) && f(x+Delta*d) < fz
				fz = f(x+Delta*d)
				z  = x+Delta*d
			end
			if f(x-Delta*d) < f(x) && f(x-Delta*d) < fz
				fz = f(x-Delta*d)
				z  = x-Delta*d
			end
			d[i] = 0.0
		end
		if fz < f(x)
			x = z
		else
			Delta = Delta/2
		end
		@printf("%6d f(xx) = %13.6e step = %13.6e\n",k,f(x),Delta)
	end

	return x
end

function CSd(x0::Array,step0::Real,tol::Real,maxit::Int,f::Function)
	Delta = step0
	x = x0
	n = length(x)
	d = zeros(n)
	for k = 1:maxit
		if Delta <= tol
			break
		end
		i = 1
		fz= Inf
		z = zeros(n)
		for i = 1:n
			d[i] = 1.0
			if f(x+Delta*d) < f(x) && f(x+Delta*d) < fz
				fz = f(x+Delta*d)
				z  = x+Delta*d
				d[i] = 0.0
				break
			elseif f(x-Delta*d) < f(x) && f(x-Delta*d) < fz
				fz = f(x-Delta*d)
				z  = x-Delta*d
				d[i] = 0.0
				break
			end
			d[i] = 0.0			
		end
		if fz < f(x)
			x = z
			#Delta = 1.1*Delta
		else
			Delta = Delta/2
		end
		@printf("%6d f(xx) = %13.6e step = %13.6e\n",k,f(x),Delta)
	end

	return x
end

function HJ(x0::Array,step0::Real,tol::Real,maxit::Int,f::Function)
	Delta = step0
	x = x0
	n = length(x)
	d = zeros(n)
	for k = 1:maxit
		if Delta <= tol
			break
		end
		fy= f(x)
		y = x
		for i = 1:n
			d[i] = 1.0
			
			if f(y+Delta*d) < fy
				fy = f(y+Delta*d)
				y  = y+Delta*d
			elseif f(y-Delta*d) < fy
				fy = f(y-Delta*d)
				y  = y-Delta*d
			end
			d[i] = 0.0
		end
		if fy < f(x)
			z  = y + y-x
			fz = f(z)
			for i = 1:n
				d[i] = 1.0
			
				if f(z+Delta*d) < fz
					z  = z+Delta*d
					fz = f(z)
				elseif f(z-Delta*d) < fz
					z  = z-Delta*d
					fz = f(z)
				end
				d[i] = 0.0
			end
			if fz < fy
				x = z
			else
				x = y
			end
		else
			Delta = Delta/2
		end
		@printf("%6d f(xx) = %13.6e step = %13.6e\n",k,f(x),Delta)
	end

	return x
end
